<!--- Heading --->
<div align="center">
  <h1>ak_transcribe</h1>
  <p>
    An awesome README template for your projects! 
  </p>
</div>
<br />

<!-- Table of Contents -->
<h2>Table of Contents</h2>

- [1. About the Project](#1-about-the-project)
  - [1.1. Screenshots](#11-screenshots)
  - [1.2. Features](#12-features)
- [2. Getting Started](#2-getting-started)
  - [2.1. Prerequisites](#21-prerequisites)
  - [2.2. Dependencies](#22-dependencies)
  - [2.3. Installation](#23-installation)
    - [2.3.1. Production](#231-production)
    - [2.3.2. Development](#232-development)
- [3. Usage](#3-usage)
  - [3.1. Ollama - Local AI](#31-ollama---local-ai)
  - [3.2. Encryption](#32-encryption)
- [4. Development](#4-development)
- [5. Roadmap](#5-roadmap)
- [6. FAQ](#6-faq)
- [7. License](#7-license)
- [8. Contact](#8-contact)
- [9. Acknowledgements](#9-acknowledgements)

<!-- About the Project -->
## 1. About the Project
<!-- Screenshots -->
### 1.1. Screenshots

<div align="center"> 
  <img src="https://placehold.co/600x400?text=Your+Screenshot+here" alt="screenshot" />
</div>

<!-- Features -->
### 1.2. Features

- Feature 1
- Feature 2
- Feature 3

<!-- Getting Started -->
## 2. Getting Started

<!-- Prerequisites -->
### 2.1. Prerequisites

Python 3.11 or above

### 2.2. Dependencies

Create the virutual environment and install dependencies

```bash
  pip install flit  
```

<!-- Installation -->
### 2.3. Installation

#### 2.3.1. Production

Install with flit

```bash
  flit install --deps production
```

#### 2.3.2. Development

Download the git and install via flit

```bash
  git clone https://github.com/rpakishore/Template-Python.git
  cd Template-Python
  pip install flit
  flit install
```

<!-- Usage -->
## 3. Usage

```python
from ak_transcribe import debug
debug(True) #For debug messages, Can be skipped.
```

### 3.1. Ollama - Local AI

Control the locally hosted Ollama module

```python
from ak_transcribe.ollama import Ollama

ollama = Ollama(url='prx-01-ai:11434')

ollama.local                                                #list local models
ollama.copy(source='llama2', destination='llama2-backup')   #Copy an existing local model
ollama.delete(model_name='llama2')                          #Delete model and it's data
ollama.show(model_name='llama2')                            #Show info of local model
ollama.heartbeat()                                          #Check if Ollama is running
ollama.public_models                                        #List public models
ollama.pull(model_name='llama2')                            #pull a model from registry

#generate response
response, context = ollama.generate(
    model_name='mistral',
    prompt='Why is the sky blue in color?')

#create a model
ollama.create(
    model_name='mario', 
    modelfile='FROM llama2\nSYSTEM You are mario from Super Mario Bros.')
```

### 3.2. Encryption

Minor encryption/decryption algoritm w/ Fernet. Also supports direct obscuring/unobscuring function

```python
from ak_transcribe.cryptography import obscure, unobscure, encrypt_text, decrypt_text

obscure(text="Hello World")     # Obscure the text without encryption
unobscure(obscured='eNrzSM3JyVcIzy_KSQEAGAsEHQ==')  # Unobscure the text

encrypt_text(text='Hello World!', password='admin123')  # Encrypt w/ Fernet
decrypt_text(encrypted_text='eaX34dw=', password='admin123')  # Decrypt w/ Fernet
```

## 4. Development

1. Open the project directory in vscode
2. Update the app name under `pyproject.toml`
3. Change the folder name from `src\ak_transcribe` to `src\<app_name>`, and propate the changes to the subfolders.
4. Review the dependencies under `pyproject.toml` and remove as needed.
5. Remove unneeded dependencies from `src\<app_name>\`

<!-- Roadmap -->
## 5. Roadmap

- [x] Set up a skeletal framework
- [ ] Todo 2

<!-- FAQ -->
## 6. FAQ

- Question 1
  - Answer 1

- Question 2
  - Answer 2

<!-- License -->
## 7. License

See [LICENSE](/LICENSE) for more information.

<!-- Contact -->
## 8. Contact

Arun Kishore - [@rpakishore](mailto:pypi@rpakishore.co.in)

Project Link: [https://github.com/rpakishore/Template-Python](https://github.com/rpakishore/Template-Python)

<!-- Acknowledgments -->
## 9. Acknowledgements

- [Awesome README Template](https://github.com/Louis3797/awesome-readme-template/blob/main/README-WITHOUT-EMOJI.md)
- [Shields.io](https://shields.io/)